function f = KFE_dynamics(parameters,results,f0)
% This codes computes the dynamics of the KFE equation in a Bewley economy with nominal
% long-term debt
% Developped by Nuo and Thomas (2015) 
I    = parameters.I;                % numer of points
dt   = parameters.dt; 
N    = parameters.N;         % number of time periods

f      = cell(1,N);          % Distribution

f{1}   = f0;                 % Initial value

for n=1:N-1
    A  = results.A_n{n};
    AT = A';
    %Implicit method in Updating Distribution.
    ff = f{n};
    ff_stacked      = [ff(:,1);ff(:,2)]; 
    ff_next_stacked = (speye(2*I) - AT*dt) \ ff_stacked;
    ff_next         = [ff_next_stacked(1:I),ff_next_stacked(I+1:2*I)];
    f{n+1} = ff_next;
end

