% % % 2 COMPUTES THE DYNAMICS 

initial_dist         = 1; % 0 empirical 1 gaussian
timeless             = 0; % If zero, zero-optimal policies, if 1 timeless optimal
parameters.timeless  = timeless;

T      = 200;             % Number of years of the transition
dt     = 1/12;            % Time interval
N      = T/dt;            % number of time intervals



% Building the initial distribution
if initial_dist         == 0 
    f0(:,1)        = construct_initial_dist(amin,amax,I);
    f0(:,2)        = f0(:,1) ;
else
    f0(:,1)        = construct_gaussian(amin,amax,I, mu_G, sigma_G);
    f0(:,2)        = f0(:,1) ;
end

f0(:,1)  =  f0(:,1) * la2 /(la2+la1);
f0(:,2)  =  f0(:,2) * la1 /(la2+la1);

f0_sum    = sum(sum(f0*results.da));
f0        = f0/f0_sum;
r_bar_n  = ones(1,N) * r_bar;


%%
% Step 0. Steady_state distribution
results_ss        = results;
parameters.dt     = dt;
parameters.N      = N;

if mode == 1 % Exogenos temporary inflation/ROW interest rate  shock
    pi_n     = zeros(1,N);
   
    % Steps 1&2. Bond pricing and HJB
    results           = HJB_dynamics(parameters,results, pi_n,r_bar_n);
    
    % Step 3. KF
    f = KFE_dynamics(parameters,results,f0);
else         % optimal monetary policy
    results.f0            = f0;
    parameters.xi         = 0.05;         % adjustment parameter
    parameters.crit_pi    = 2*10^(-4);    % convergence ctrit algorithm   
    parameters.maxit_pi   = 100;          % convergence ctrit algorithm  
    %Step 4
    if mode ==0 
        pi_n = optimal_dynamics(parameters,r_bar_n,results,pi);
    else
        pi_n = ramsey_dynamics(parameters,r_bar_n,results,pi);
    end
    % Steps 1&2. Bond pricing and HJB
    results           = HJB_dynamics(parameters,results, pi_n,r_bar_n);
    % Step 3. KF
    f = KFE_dynamics(parameters,results,f0);
end
% 
% if mode == 1
%     plotting_inflation
% else
%     plotting_inflation
%     plot_initial
% end
