%MAIN PROGRAM
% Galo Nuno, Carlos Thomas (2015)
%clear all; 
clc;
mode          = 2;                          % 0 optimal inflation discretion, 1 exogenous inflation, 2 optimal inflation commitment

%PARAMETERS
pi_guess      = 0.0;                          % inflation rate     
bond_duration =  4.5;                          % in years                                                                     
r_bar         = 0.03;                       % world interest rate
delta         = 1/bond_duration - r_bar;    % debt duration 1/delta
gamma         = 1.000000001;                % CRRA utility with parameter s
rho           = 0.03016;                     % discount rate
la1           = 0.72;                       % transition prob
la2           = la1 * 0.10 /(1-0.10);
z2            = (la1 + la2) / (la1 + 0.71*la2);% labor productivity
z1            = z2*0.71;
amin          = -3.6;                         % borrowing constraint
amax          = 10;                         % max value of assets

%Psi computation   -inflation costs
epsilon  = 11;
duration = 3/4;
lambda   = 1/ duration;
psi      = (epsilon-1)/lambda/(lambda+rho);
                       
I        = 1000;                            % numer of points
maxit    = 100;                             % max number of iterations
crit     = 10^(-6);                         % convergence ctrit 
Delta    = 1000;                            % Delta in HJB

parameters.r_bar  = r_bar;
parameters.delta  = delta;
parameters.gamma  = gamma;
parameters.rho    = rho;
parameters.z1     = z1;
parameters.z2     = z2;
parameters.la1    = la1;
parameters.la2    = la2;
parameters.I      = I;
parameters.amin   = amin;
parameters.amax   = amax;
parameters.maxit  = maxit;
parameters.crit   = crit;
parameters.Delta  = Delta;
parameters.psi    = psi;
%---------------------------------------------------
% % 1 STEADY-STATE
if mode == 0       % optimal under discretion
        pi           = fzero(@(pi) optimal_stationary(parameters,pi), pi_guess);
else if mode ==1  % exogenous
        pi           = pi_guess;
     else        % optimal runder commitment
         flag_mu      = 0;
         pi           = fzero(@(pi) ramsey(parameters,pi,flag_mu), pi_guess);
     end
end
results      = HJB_stationary(parameters,pi);
distribution = KFE_stationary(parameters,results);
Moments
% plotting


%-----------------------------------------------------
%2 CODE FOR INFLATION SHOKS
%Set type_shock  = 0 and timeless  = 0 and 
% type_shock     = 0; % 0 inflation 1 sudden stop 2 transition dynamics 3 initial zero inflation
% T              = 800;             % Number of years of the transition
% timeless       = 0; % If zero, zero-optimal policies, if 1 timeless optimal
% dynamics

%-----------------------------------------------------
% 3 CODE FOR TRANSITIONAL DYNAMICS
% Set type_shock  = 0 and timeless  = 0 and 
type_shock     = 3; % 0 inflation 1 sudden stop 2 transition dynamics 3 initial zero inflation
T              = 800;             % Number of years of the transition
timeless       = 0; % If zero, zero-optimal policies, if 1 timeless optimal
dynamics
plotting_transitional_dynamics
%-----------------------------------------------------
%5 CODE FOR WELFARE
% You need to have stored Ramsey, zero and MPE
% Welfare

%-----------------------------------------------------
%5 CODE FOR ROBUSTNESS
% robustness

%------------------------------------------------------
% 6 CODE FOR "INSPECTING THE MECHANISM"
% mu_G_n    = [0       0    0      0    0      0     0       -0.5   -1      -1.5];  
% sigma_G_n = [0.01  0.4  0.8    1.2  1.6   1.9    2.1      0.01  0.01     0.01];
% 
% save gaussian
% pi_g = zeros(size(mu_G_n));
% 
% for i = 1:length(mu_G_n)
%     disp('round')
%     disp(i)
%     mu_G    = mu_G_n(i);
%     sigma_G = sigma_G_n(i);
%     dynamics_empirical;
%     pi_g(i) = pi_n(2);
%     save gaussian pi_g i mu_G_n sigma_G_n -append
%     clear
%     load gaussian    
% end
% plotting_gaussian

%--------------------------------------------------------
% % 7 CODE FOR "AGGREGATE SHOCKS"
% %Set type_shock  = 1 and timeless  = 1
% % Interest rate shock
% type_shock     = 1;               % 0 inflation 1 interest rate shock 2 transition dynamics 3 initial zero inflation 4 TFP shock
% T              = 200;             % Number of years of the transition
% timeless       = 1;               % If zero, zero-optimal policies, if 1 timeless optimal
% r_init          = r_bar + 0.01;   % initial r in asudden stop
% dynamics

% % TFP shock
% type_shock     = 4;               % 0 inflation 1 interest rate shock 2 transition dynamics 3 initial zero inflation 4 TFP shock
% T              = 800;             % Number of years of the transition
% timeless       = 1;               % If zero, zero-optimal policies, if 1 timeless optimal
% Y_init          =1 - 0.01;        % initial y 
% dynamics


%----------------------------------------------------
% % % % 8 CODE FOR WELFARE ANALYSIS
%  plotting_welfare