%RAMSEY
% load Ramsey

fagg = zeros(I,N);
df = zeros(I,N);

for n=1:N
    fagg(:,n) =  sum(f{n}(:,:), 2);
    df(:,n)   = fagg(:,n) -  fagg(:,1);
end

time_max = 30;
time  = 0:dt:time_max;
Nmax = length(time);
a_max  = 4;
aaa    = amin:results.da:a_max;
aNmax = length(aaa);

%%
figure(20)
% subplot(221)
% mesh(aaa,time,fagg(1:aNmax,1:Nmax)')
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% ylabel('Years','FontSize',14,'interpreter','latex')
% zlim([0 0.3])
% view(-140,15)
% title('Density $f(t,a)$: Commitment','interpreter','latex','FontSize',16)
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)

%%
subplot(223)
mesh(aaa,time,df(1:aNmax,1:Nmax)')
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
ylabel('Years','FontSize',14,'interpreter','latex')
zlim([-0.035 0.025])
view(-140,15)
title('$f(t,a)- f(0,a)$: Commitment','interpreter','latex','FontSize',16)
xlabel('Assets, $a$','interpreter','latex','FontSize',16)

