%Plotting dynamics
Welfare2          =         sum(sum(results.V_n(:,:,1) .* f{1} *results.da));


if mode == 1
    Color  = [1 0 0]; %red
    line   = 2;
    style  = '-.';
    Color2 = 'bo';
    
else
    if mode == 2
        Color  = [0 0 1]; %blue
        line   = 2;
        style  = '-';
        Color2 = 'bo';       
    else

        Color  = [0 0.4 0.1]; %green
        line   = 2;
        style  = '-';
        Color2 = 'go';
    end
end

stylex = ':';
%
% Computations
time  = (1:N) * dt;
range = find(results.a<0,1,'last');
mu_n =zeros(N,1);
mu_n(1) = 0;

for n=1:N
    A_n(n) = sum(sum(results.aa.*f{n} *results.da));
    C_n(n) = sum(sum(results.c_n(:,:,n).*f{n} *results.da));
    Y_n(n) = sum(sum(results.zz.*f{n} *results.da));
    B_n(n) = sum(sum(results.aa(1:range,:).*f{n}(1:range,:) *results.da));
    U_n(n) = sum(sum(((results.c_n(:,:,n)).^(1-gamma)/(1-gamma)-psi/2*pi_n(n)^2) .*f{n} *results.da));
    discount(n) = exp(-rho*n*dt);
    W_n(n) = sum(sum(results.V_n(:,:,n).*f{n} *results.da));
    C_n_top(n) = sum(sum(results.c_n(range+1:end,:,n).*f{n}(range+1:end,:) *results.da));
    C_n_bottom(n) = sum(sum(results.c_n(1:range,:,n).*f{n}(1:range,:) *results.da));
     A_n_top(n) = sum(sum(results.aa(range+1:end,:).*f{n}(range+1:end,:) *results.da));
    A_n_bottom(n) = sum(sum(results.aa(1:range,:).*f{n}(1:range,:) *results.da));
    Y_n_top(n) = sum(sum(results.zz(range+1:end,:).*f{n}(range+1:end,:) *results.da));
    Y_n_bottom(n) = sum(sum(results.zz(1:range,:).*f{n}(1:range,:) *results.da));
    if n>1
        num              = sum(sum(f{n}(2:end-1,:).*(results.aa(2:end-1,:)*delta + results.zz(2:end-1,:)-results.c_n(2:end-1,:,n)).*0.5.*(results.V_n(3:end,:,n)-results.V_n(1:end-2,:,n))));
        mu_n(n)          = mu_n(n-1) + dt * mu_n(n-1) * (rho - r_bar_n(n) -pi_n(n) -delta) + dt /(results.Q_n(n)).^2 *  num; 
    end
    WAD_n1(n)= -1/psi*sum(sum(f{n}(2:end-1,:).*results.aa(2:end-1,:).*0.5.*(results.V_n(3:end,:,n)-results.V_n(1:end-2,:,n))));
end

C_top    = sum(sum(results.c(range:end,:).*f0(range:end,:) *results.da));
C_bottom = sum(sum(results.c(1:range,:).*f0(1:range,:) *results.da));
Y_top    = sum(sum(results.zz(range:end,:).*f0(range:end,:) *results.da));
Y_bottom = sum(sum(results.zz(1:range,:).*f0(1:range,:) *results.da));
r_n      = delta ./ results.Q_n -delta -pi_n;
if mode == 2
    WAD_n    = pi_n -1/psi*mu_n' .* results.Q_n;
else
    WAD_n    = pi_n;
end


time_max = 30;

figure(1)
Moments

origin = 1; 
time = time(1:end-origin+1);

%%

%inflation
subplot(331)
plot(time,pi_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
hold on
grid on
ylabel('\%','FontSize',12,'interpreter','latex')
title('(a) Inflation, $\pi$','FontSize',14,'interpreter','latex') 
% xlabel('years','FontSize',14,'interpreter','latex')
% plot(time,ones(1,N)*100*pi,'Color',Color,'LineStyle',stylex,'Linewidth',line) 
xlim([0 time_max])
if mode == 2
% text(0,0,'Commitment','FontSize',14,'interpreter','latex')
% text(0,0,'Discretion','FontSize',14,'interpreter','latex')
% text(0,0,'$\pi = 0$','FontSize',14,'interpreter','latex')
% legend({'Commitment','Discretion','$\pi = 0$'},'FontSize',14,'interpreter','latex')
end

subplot(332)
plot(time,WAD_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
hold on
grid on
ylabel('\%','FontSize',12,'interpreter','latex')
title('(b) $E_f$ [$NNP * MUC$]','FontSize',14,'interpreter','latex') 
% xlabel('years','FontSize',14,'interpreter','latex')
% plot(time,ones(1,N)*100*pi,'Color',Color,'LineStyle',stylex,'Linewidth',line) 
xlim([0 time_max])

if mode == 2
subplot(333)
plot(time,1/psi*mu_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
hold on
grid on
plot(time,1/psi*mu_n(origin:end)' .* results.Q_n(origin:end)*100,'Color',Color,'LineStyle','-.','Linewidth',line)
ylabel('\%','FontSize',12,'interpreter','latex')
title('(c) Costate, $\mu$','FontSize',14,'interpreter','latex') 
% xlabel('years','FontSize',14,'interpreter','latex')
% plot(time,ones(1,N)*100*pi,'Color',Color,'LineStyle',stylex,'Linewidth',line) 
xlim([0 time_max])
text(0,0,'$\mu_t$','FontSize',14,'interpreter','latex')
text(0,0,'$\mu_t Q_t$','FontSize',14,'interpreter','latex')
end

%bond price
subplot(334)
plot(time,results.Q_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
hold on
grid on
title('(d) Bond price, $Q$','FontSize',14,'interpreter','latex') 
% xlabel('years','FontSize',14,'interpreter','latex')
% plot(time,ones(1,N)*100*pi,'Color',Color,'LineStyle',stylex,'Linewidth',line) 
xlim([0 time_max])



% Aggregate assets
subplot(335)
plot(time,A_n(origin:end)./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(e) Net assets, $\bar{a}$','FontSize',14,'interpreter','latex')
ylabel('\% GDP','FontSize',12,'interpreter','latex')
hold on
grid on
xlim([0 time_max])
% 
% % Aggregate assets (creditors)
% subplot(335)
% plot(time,A_n_top(origin:end)./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
% title('(e) Assets, creditors (face value)','FontSize',14,'interpreter','latex')
% ylabel('\% GDP','FontSize',12,'interpreter','latex')
% hold on
% xlabel('years','FontSize',14,'interpreter','latex')
% xlim([0 time_max])


% Aggregate assets debtors
subplot(336)
plot(time,A_n_bottom(origin:end)./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(f) Net debt, $\bar{b}$','FontSize',14,'interpreter','latex')
ylabel('\% GDP','FontSize',12,'interpreter','latex')
hold on
grid on
xlim([0 time_max])

% Consumption assets

subplot(337)
plot(time,(C_n(origin:end))./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(g) Consumption, $\bar{c}$','FontSize',14,'interpreter','latex')
hold on
grid on
ylabel('\% GDP','FontSize',12,'interpreter','latex')
xlabel('years','FontSize',14,'interpreter','latex')
xlim([0 time_max])


%Deficit creditors
subplot(338)
plot(time,(C_n_top(origin:end))./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(h) Consumption, creditors','FontSize',14,'interpreter','latex')
hold on
grid on
ylabel('\% GDP','FontSize',12,'interpreter','latex')
xlabel('years','FontSize',14,'interpreter','latex')
xlim([0 time_max])


%Deficit debtors
subplot(339)
plot(time,(C_n_bottom(origin:end))./Y_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(i) Consumption, debtors','FontSize',14,'interpreter','latex')
hold on
grid on
ylabel('\% GDP','FontSize',12,'interpreter','latex')
xlabel('years','FontSize',14,'interpreter','latex')
xlim([0 time_max])

%%
% figure(40)
% 
% % % 
% % Color  = [1 0 0]; %red
% % line   = 2;
% % style  = '-.';
% % Color2 = 'bo';
% 
% % 
% Color  = [0 0 1]; %blue
% line   = 2;
% style  = '--';
% Color2 = 'bo';
% 
% % Color  = [0 0.4 0.1]; %green
% % line   = 2;
% % style  = '-';
% % Color2 = 'go';
% 
% 
% 
% plot(time,pi_n(origin:end)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
% hold on
% grid on
% ylabel('\%','FontSize',12,'interpreter','latex')
% title('Inflation, $\pi$','FontSize',14,'interpreter','latex') 
%  xlabel('years','FontSize',14,'interpreter','latex')
% % plot(time,ones(1,N)*100*pi,'Color',Color,'LineStyle',stylex,'Linewidth',line) 
% xlim([0 time_max])
% if mode == 2
% % text(0,0,'Commitment','FontSize',14,'interpreter','latex')
% % text(0,0,'Discretion','FontSize',14,'interpreter','latex')
% % text(0,0,'$\pi = 0$','FontSize',14,'interpreter','latex')
% % legend({'Commitment','Discretion','$\pi = 0$'},'FontSize',14,'interpreter','latex')
% end
% % legend({'Baseline (4.5 years)','Annual','Quarterly'},'FontSize',12,'interpreter','latex')