% PLOTTING STEADY STATE WELFARE ANALYSIS
 pi_loop = -0.02:0.001:0.018;
 N_loop = length(pi_loop);
 Welfare = zeros( N_loop,1);
 u = zeros( N_loop,1);
 U = zeros( N_loop,1);
 for n = 1:N_loop
     pi           = pi_loop(n);
     results      = HJB_stationary(parameters,pi);
     distribution = KFE_stationary(parameters,results);
     Welfare(n)   = sum(sum(results.V .* distribution *results.da));
     C            = sum(sum(results.c .* distribution *results.da));
     U(n)         = 1/rho* ((C^(1-gamma)-1)/(1-gamma) -psi/2 * pi^2);
     u(n)         = 1/rho*sum(sum(((results.c.^(1-gamma)-1)/(1-gamma)-psi/2 * pi^2) .* distribution *results.da)) - U(n);     
 end
%  % optimal under discretion
%  piM           = fzero(@(pi) optimal_stationary(parameters,pi), pi_guess);
%  results      = HJB_stationary(parameters,piM);
%  distribution = KFE_stationary(parameters,results);
%  WelfareM   = sum(sum(results.V .* distribution *results.da));
%  CM            = sum(sum(results.c .* distribution *results.da));
%  UM         = 1/rho*(CM^(1-gamma)-1)/(1-gamma);
%  uM         = 1/rho*sum(sum((results.c.^(1-gamma)-1)/(1-gamma) .* distribution *results.da)) - UM;     
% optimal under commitment
 flag_mu      = 0;
 piR           = fzero(@(pi) ramsey(parameters,pi,flag_mu), pi_guess);
 results      = HJB_stationary(parameters,piR);
 distribution = KFE_stationary(parameters,results);
 WelfareR     = sum(sum(results.V .* distribution *results.da));
%  CR           = sum(sum(results.c .* distribution *results.da));
%  UR           = 1/rho*(CR^(1-gamma)-1)/(1-gamma);
%  uR           = 1/rho*sum(sum((results.c.^(1-gamma)-1)/(1-gamma) .* distribution *results.da)) - UR;     
 save welfareSS

%%
Color1  = [0 0 1]; %blue
style1 = '-';
figure(5)
a = results.a;
plot(100*pi_loop,Welfare,'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
% Color1  = [1 0 0]; 
% style1 = '--';
% plot(100*pi_loop,U,'Color',Color1,'LineStyle',style1,'LineWidth',2)
% Color1  = [0 0.4 0.1]; 
% style1 = '-.';
% plot(100*pi_loop,u,'Color',Color1,'LineStyle',style1,'LineWidth',2)
% legend({'Total','Representative agent','Dispersion'},'interpreter','latex','FontSize',14)

Color1  = [0 0 1]; %blue
% plot(100*piM,WelfareM,'*','LineWidth',2)
plot(100*piR,WelfareR,'o','LineWidth',2)
% text(100*piM,0,'Discretion','FontSize',14,'interpreter','latex')
% text(100*piR,0,'Optimal inflation - borr. lim. face value','FontSize',14,'interpreter','latex')

%grid
xlabel('Steady-state inflation, $\pi$ (\%)','interpreter','latex','FontSize',16)
ylabel('utils','interpreter','latex','FontSize',16)
title('Steady-state welfare','interpreter','latex','FontSize',16)
xlim([-2 1.7])
ylim([-.6 0])
