function output = ramsey(parameters,pi,flag_mu)
%This code computes the optimal inflation rate under discretion
% Developped by Nuo and Thomas (2015)
    results      = HJB_stationary(parameters,pi);
    distribution = KFE_stationary(parameters,results);
    %output       = sum(sum(distribution(2:end,:).*results.aa(2:end,:).*(results.V(2:end,:)-results.V(1:end-1,:))));
    
    r_bar         = parameters.r_bar;            % inflation rate
    delta         = parameters.delta;            % debt duration 1/lambda
    rho           = parameters.rho;              % discount rate
    psi           = parameters.psi; 
    gamma         = parameters.gamma;
    
    mu           =   (1/ results.Q *psi*pi + sum(sum(distribution.*results.aa.*(results.c).^(-gamma)*results.da))) ;
    num          = sum(sum(distribution.*(results.aa*delta + results.zz-results.c).*(results.c).^(-gamma)*results.da ));
    if flag_mu ==0
        output       =  (rho -r_bar -delta -pi)*mu*results.Q + num;
    else
        output=mu;
    end
    


